# coding: utf-8

"""
    Measurements Generation API

    Measurements Generation API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacetower_orbit_extrapolation_python_client.models.earth_ellipsoid_configuration import EarthEllipsoidConfiguration
from spacetower_orbit_extrapolation_python_client.models.field_description import FieldDescription
from spacetower_orbit_extrapolation_python_client.models.ground_station import GroundStation
from typing import Optional, Set
from typing_extensions import Self

class AzimuthElevationMeasurements(BaseModel):
    """
    Measurement sample consisting of azimuth and elevation as observed from a given site on Earth's surface
    """ # noqa: E501
    dates: List[str]
    description: Optional[List[FieldDescription]] = None
    ground_station: Optional[GroundStation] = Field(default=None, alias="groundStation")
    earth_ellipsoid_configuration: Optional[EarthEllipsoidConfiguration] = Field(default=None, alias="earthEllipsoidConfiguration")
    data: List[List[Union[StrictFloat, StrictInt]]] = Field(description="[[azimuth[rad], elevation[rad]], ...]")
    __properties: ClassVar[List[str]] = ["dates", "description", "groundStation", "earthEllipsoidConfiguration", "data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzimuthElevationMeasurements from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in description (list)
        _items = []
        if self.description:
            for _item in self.description:
                if _item:
                    _items.append(_item.to_dict())
            _dict['description'] = _items
        # override the default output from pydantic by calling `to_dict()` of ground_station
        if self.ground_station:
            _dict['groundStation'] = self.ground_station.to_dict()
        # override the default output from pydantic by calling `to_dict()` of earth_ellipsoid_configuration
        if self.earth_ellipsoid_configuration:
            _dict['earthEllipsoidConfiguration'] = self.earth_ellipsoid_configuration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzimuthElevationMeasurements from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dates": obj.get("dates"),
            "description": [FieldDescription.from_dict(_item) for _item in obj["description"]] if obj.get("description") is not None else None,
            "groundStation": GroundStation.from_dict(obj["groundStation"]) if obj.get("groundStation") is not None else None,
            "earthEllipsoidConfiguration": EarthEllipsoidConfiguration.from_dict(obj["earthEllipsoidConfiguration"]) if obj.get("earthEllipsoidConfiguration") is not None else None,
            "data": obj.get("data")
        })
        return _obj


