# coding: utf-8

"""
    Measurements Generation API

    Measurements Generation API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacetower_orbit_extrapolation_python_client.models.earth_ellipsoid_configuration import EarthEllipsoidConfiguration
from spacetower_orbit_extrapolation_python_client.models.measurement_request import MeasurementRequest
from spacetower_orbit_extrapolation_python_client.models.measurement_type import MeasurementType
from typing import Optional, Set
from typing_extensions import Self

class GpsNmeaMeasurementsRequest(MeasurementRequest):
    """
    Request for generating a sample consisting of quantities found in RMC and GGA NMEA sentences. These are geodetic latitude (WGS84), longitude, altitude and the norm of the terrestrial velocity
    """ # noqa: E501
    geodetic_latitude_standard_deviation: Optional[Union[StrictFloat, StrictInt]] = Field(default=0.0572958, description="Units [rad]", alias="geodeticLatitudeStandardDeviation")
    longitude_standard_deviation: Optional[Union[StrictFloat, StrictInt]] = Field(default=0.0572958, description="Units [rad]", alias="longitudeStandardDeviation")
    geodetic_altitude_standard_deviation: Optional[Union[StrictFloat, StrictInt]] = Field(default=0.1, description="Units [m]", alias="geodeticAltitudeStandardDeviation")
    ecf_velocity_norm_standard_deviation: Optional[Union[StrictFloat, StrictInt]] = Field(default=14, description="Units [m/s]", alias="ecfVelocityNormStandardDeviation")
    earth_ellipsoid_configuration: EarthEllipsoidConfiguration = Field(alias="earthEllipsoidConfiguration")
    __properties: ClassVar[List[str]] = ["measurementType", "geodeticLatitudeStandardDeviation", "longitudeStandardDeviation", "geodeticAltitudeStandardDeviation", "ecfVelocityNormStandardDeviation", "earthEllipsoidConfiguration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GpsNmeaMeasurementsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of earth_ellipsoid_configuration
        if self.earth_ellipsoid_configuration:
            _dict['earthEllipsoidConfiguration'] = self.earth_ellipsoid_configuration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GpsNmeaMeasurementsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "measurementType": obj.get("measurementType"),
            "geodeticLatitudeStandardDeviation": obj.get("geodeticLatitudeStandardDeviation") if obj.get("geodeticLatitudeStandardDeviation") is not None else 0.0572958,
            "longitudeStandardDeviation": obj.get("longitudeStandardDeviation") if obj.get("longitudeStandardDeviation") is not None else 0.0572958,
            "geodeticAltitudeStandardDeviation": obj.get("geodeticAltitudeStandardDeviation") if obj.get("geodeticAltitudeStandardDeviation") is not None else 0.1,
            "ecfVelocityNormStandardDeviation": obj.get("ecfVelocityNormStandardDeviation") if obj.get("ecfVelocityNormStandardDeviation") is not None else 14,
            "earthEllipsoidConfiguration": EarthEllipsoidConfiguration.from_dict(obj["earthEllipsoidConfiguration"]) if obj.get("earthEllipsoidConfiguration") is not None else None
        })
        return _obj


